Subject: RFC 4861:-Link-Local address joining all-node multicast group.

From: niviya vijayan <[email-masked]>
Date: Fri, 16 Apr 2010 13:48:44 +0530

Hi ,

 I have a query regarding the interface initialization process for an ipv6
enabled interface.

 As per the RFC4861, the node has to join

a.       All-node multicast address{FE02::1}

b.      Solicited multicast address {FF02::1:ff00:<last 24 bits of
ipaddress>}

I have tried capturing  packets for one of the switch while configuring an
ipv6 address. I could see IPv6 node (Ipv6 address) joining ‘All node
multicast address’ and ‘Solicited multicast address’. Apart from that I am
seeing an extra join request from the Link Local address to the ‘All node
multicast address’.  Any specific reason for this? Is this a correct
behaviour ?or is there any requirement for joining link local address on the
all node multicast node while creating an ipv6 address on the interface? why
it is required? if it is required, then this message will repeat for each &
every ipv6 address created on an interface since it has only one link-local
address.

 I havent seen anywhere RFC taking about this. please help me to understand
this behaviour.

RFC 4861 Statement:- 7.2.1.Interface Initialization
“When a multicast-capable interface becomes enabled, the node MUST join the
all-nodes multicast address on that interface, as well as the solicited-
   node multicast address corresponding to each of the IP addresses assigned
to the interface.”

Thnaks & Regards,
Niviya

---

From: Suresh Krishnan <[email-masked]>
Date: Fri, 16 Apr 2010 11:11:58 -0400

Hi Niviya,

On 10-04-16 04:18 AM, niviya vijayan wrote:
> Hi ,
>  
>  I have a query regarding the interface initialization process for an 
> ipv6 enabled interface.
>  
> 
> I have tried capturing  packets for one of the switch while configuring 
> an ipv6 address. I could see IPv6 node (Ipv6 address) joining ‘All node 
> multicast address’ and ‘Solicited multicast address’. Apart from that I 
> am seeing an extra join request from the Link Local address to the ‘All 
> node multicast address’.  Any specific reason for this? Is this a 
> correct behaviour ?or is there any requirement for joining link local 
> address on the all node multicast node while creating an ipv6 address on 
> the interface? why it is required? if it is required, then this message 
> will repeat for each & every ipv6 address created on an interface since 
> it has only one link-local address.

It is very strange that you see a join for the all nodes multicast 
address. Nodes don't have to send a MLD join for the link-local 
all-nodes multicast address and I have never seen an implementation that 
does this. What I would expect is 2 MLD (listener report) joins

1) MLD join for the solicited node multicast address from the 
unspecified address (to test for the uniqueness of the tentative 
link-local address).
2) MLD join for the solicited node multicast address from the link-local 
address.

Cheers
Suresh

---

From: Alexandru Petrescu <[email-masked]>
Date: Fri, 16 Apr 2010 18:00:01 +0200

Le 16/04/2010 17:11, Suresh Krishnan a écrit :
>> b. Solicited multicast address {FF02::1:ff00:<last 24 bits of ipaddress>}
>>
>>
>>
>> an ipv6 address. I could see IPv6 node (Ipv6 address) joining ‘All
>> node multicast address’ and ‘Solicited multicast address’. Apart from
>> that I am seeing an extra join request from the Link Local address to
>> the ‘All node multicast address’. Any specific reason for this? Is
>> this a correct behaviour ?or is there any requirement for joining link
>> local address on the all node multicast node while creating an ipv6
>> address on the interface? why it is required? if it is required, then
>> this message will repeat for each & every ipv6 address created on an
>> interface since it has only one link-local address.
>

Strange, what I see is an exclude filter... I have to think what's left 
if the excluded things go away.

Alex

>
> Cheers
> Suresh
>
>
> --------------------------------------------------------------------
> IETF IPv6 working group mailing list
> [email-masked]
> Administrative Requests: https://www.ietf.org/mailman/listinfo/ipv6
> --------------------------------------------------------------------
>

---

From: Suresh Krishnan <[email-masked]>
Date: Fri, 16 Apr 2010 15:51:33 -0400

Hi Alex,

> if the excluded things go away.

I think what you are seeing is a MLD Filter Mode Change Record (Record 
Type 4) which is setting the filter mode to EXCLUDE with an empty set. 
This is SOP for starting to listen for multicast traffic from ANY source.

Cheers
Suresh

---

From: niviya vijayan <[email-masked]>
Date: Tue, 20 Apr 2010 14:39:31 +0530

Hi Suresh,

Thanks for your reply. I have a doubt on your answer.

As per your comments, there can be two MLD report msg which will join the
node in solicited multicast group . But in the RFC 4861, they have mention
there should be a join request to all node multicast group.
.

I have one more query  regarding NA messages.

While creating ipv6 address on an interface, unsolicited NA messages will be
sent to all node multicast address to inform all other nodes in the network.
When i tried this scenario , I have seen two NA messages.

1) source as ipv6 address and destination as ipv6 all node address.
2) source as link-local address and destination as ipv6 all node address.

My question is, whenever there is a change in ipv6 address on a node, both
these 2 NA messages will propogate through the network?
or is it really required to share about the link-local address as we are not
at all changing the ipv6 link-local address.?

Thanks in advance,
Niviya

On Fri, Apr 16, 2010 at 8:41 PM, Suresh Krishnan <
[email-masked]> wrote:

> It is very strange that you see a join for the all nodes multicast address.
> Nodes don't have to send a MLD join for the link-local all-nodes multicast
> address and I have never seen an implementation that does this. What I would
> expect is 2 MLD (listener report) joins
>
> 1) MLD join for the solicited node multicast address from the unspecified
> address (to test for the uniqueness of the tentative link-local address).

---

From: "JOSHI, SHRINIVAS ASHOK (SHRINIVAS ASHOK)" <[email-masked]>
Date: Tue, 20 Apr 2010 18:18:24 +0530

>> My question is, whenever there is a change in ipv6 address on a node, both these 2 NA messages will propogate through the network?
>> or is it really required to share about the link-local address as we are not at all changing the ipv6 link-local address.?

If link local ipv6 is already active,  DAD needs to be performed only for changed ipv6 address (and not link local). 
No need to send DAD for link local once again.

--
Shree

From: [email-masked] [mailto:[email-masked]] On Behalf Of niviya vijayan
Sent: Tuesday, April 20, 2010 2:40 PM
To: Suresh Krishnan
Cc: [email-masked]
Subject: Re: RFC 4861:-Link-Local address joining all-node multicast group.

Hi Suresh,

As per your comments, there can be two MLD report msg which will join the node in solicited multicast group . But in the RFC 4861, they have mention there should be a join request to all node multicast group.
.
   
RFC 4861 Statement:- 7.2.1.Interface Initialization 
"When a multicast-capable interface becomes enabled, the node MUST join the all-nodes multicast address on that interface, as well as the solicited-    node multicast address corresponding to each of the IP addresses assigned to the interface."

While creating ipv6 address on an interface, unsolicited NA messages will be sent to all node multicast address to inform all other nodes in the network. When i tried this scenario , I have seen two NA messages. 

My question is, whenever there is a change in ipv6 address on a node, both these 2 NA messages will propogate through the network?
or is it really required to share about the link-local address as we are not at all changing the ipv6 link-local address.?
 
Thanks in advance,
Niviya

On Fri, Apr 16, 2010 at 8:41 PM, Suresh Krishnan <[email-masked]> wrote:
Hi Niviya, 

On 10-04-16 04:18 AM, niviya vijayan wrote:
Hi ,
 I have a query regarding the interface initialization process for an ipv6 enabled interface.

I have tried capturing  packets for one of the switch while configuring an ipv6 address. I could see IPv6 node (Ipv6 address) joining 'All node multicast address' and 'Solicited multicast address'. Apart from that I am seeing an extra join request from the Link Local address to the 'All node multicast address'.  Any specific reason for this? Is this a correct behaviour ?or is there any requirement for joining link local address on the all node multicast node while creating an ipv6 address on the interface? why it is required? if it is required, then this message will repeat for each & every ipv6 address created on an interface since it has only one link-local address.

It is very strange that you see a join for the all nodes multicast address. Nodes don't have to send a MLD join for the link-local all-nodes multicast address and I have never seen an implementation that does this. What I would expect is 2 MLD (listener report) joins

1) MLD join for the solicited node multicast address from the unspecified address (to test for the uniqueness of the tentative link-local address).
2) MLD join for the solicited node multicast address from the link-local address.

Cheers
Suresh

---

From: Suresh Krishnan <[email-masked]>
Date: Tue, 20 Apr 2010 18:52:53 -0400

Hi Niviya,

On 10-04-20 05:09 AM, niviya vijayan wrote:
> As per your comments, there can be two MLD report msg which will join 
> the node in solicited multicast group . But in the RFC 4861, they have 
> mention there should be a join request to all node multicast group.

As described in section 6 of RFC3810 MLD reports are not sent for the 
all-nodes multicast address

"  The link-scope all-nodes multicast address, (FF02::1), is handled as
    a special case.  On all nodes -- that is all hosts and routers,
    including multicast routers -- listening to packets destined to the
    all-nodes multicast address, from all sources, is permanently enabled
    on all interfaces on which multicast listening is supported.  No MLD
    messages are ever sent regarding neither the link-scope all-nodes
    multicast address, nor any multicast address of scope 0 (reserved) or
    1 (node-local)."

> “When a multicast-capable interface becomes enabled, the node MUST join 
> the all-nodes multicast address on that interface, as well as the 
> solicited-    node multicast address corresponding to each of the IP 
> addresses assigned to the interface.”
> 
>  
>   
> While creating ipv6 address on an interface, unsolicited NA messages 
> will be sent to all node multicast address to inform all other nodes in 
> the network. When i tried this scenario , I have seen two NA messages.
>  
> My question is, whenever there is a change in ipv6 address on a node, 
> both these 2 NA messages will propogate through the network?
> or is it really required to share about the link-local address as we are 
> not at all changing the ipv6 link-local address.?

It is unclear what the circumstances are. Specifically, what action did 
you perform that resulted in these messages? Did you change the MAC 
address of the card?

Cheers
Suresh

---

From: niviya vijayan <[email-masked]>
Date: Wed, 21 Apr 2010 10:59:08 +0530

Hi Suresh,

“When a multicast-capable interface becomes enabled, the node MUST join the
all-nodes multicast address on that interface, as well as the solicited-
 node multicast address corresponding to each of the IP addresses assigned
to the interface.”
*Any idea What does this statement mean?*

For the second query:-

I didnt change the MAC address of the card. I tried creating a new ipv6
address on the interface and I have seen these two unsolicited NA
messages.My question is , Why the node is sending unsolicited NA message (
with source as "link-local address" & destination as "all-node multicast
address").I am expecting only one unsolicited NA message( with source as
"ipv6 global address" & destination as "all-node multicast address").  I am
not at all changing the link-local address and the link-local address is
already active on the interface.

Regards,
Niviya

On Wed, Apr 21, 2010 at 4:22 AM, Suresh Krishnan <
[email-masked]> wrote:

>> the all-nodes multicast address on that interface, as well as the solicited-
>>  While creating ipv6 address on an interface, unsolicited NA messages will
>> be sent to all node multicast address to inform all other nodes in the
>> network. When i tried this scenario , I have seen two NA messages.
> It is unclear what the circumstances are. Specifically, what action did you
> perform that resulted in these messages? Did you change the MAC address of
> the card?
>

Hi Suresh,

I didnt change the MAC address of the card. I tried creating a new ipv6
address on the interface and I have seen these two unsolicited NA
messages.My question is , Why the node is sending unsolicited NA message (
with source as "link-local address" & destination as "all-node multicast
address").I am expecting only one unsolicited NA message( with source as
"ipv6 global address" & destination as "all-node multicast address").  I am
not at all changing the link-local address and the link-local address is
already active on the interface.

---

From: "JOSHI, SHRINIVAS ASHOK (SHRINIVAS ASHOK)" <[email-masked]>
Date: Wed, 21 Apr 2010 16:31:35 +0530

Niviya,

>> "When a multicast-capable interface becomes enabled, the node MUST join the all-nodes multicast address on that interface, as well as the solicited-    
>> node multicast address corresponding to each of the IP addresses assigned to the interface."
>> Any idea What does this statement mean?

[Shree] If the hosts on link are connected through a multicast aware device (e.g. switch with MLD proxy),  
these messages are intended to  inform the switch that host is interested in receiving packets destined 
to all -nodes and solicited node multicast address. 

>> Why the node is sending unsolicited NA message ( with source as "link-local address" & destination as "all-node multicast address").
>> I am expecting only one unsolicited NA message( with source as "ipv6 global address" & destination as "all-node multicast address").  
>> I am not at all changing the link-local address and the link-local address is already active on the interface.

[Shree] If you are assigning an address the node should send out Neighbor solicitation 
 as part of Duplicate Address Detection(source as unspecified address and destination as solicited node multicast address).

>From what you are seeing it looks like link layer address is getting changed, one way to verify it is through the override flag and source link layer address option
n unsolicited neighbor advertisement. Before and after you apply the ipv6 address.

--
Shree

From: [email-masked] [mailto:[email-masked]] On Behalf Of niviya vijayan
Sent: Wednesday, April 21, 2010 10:59 AM
To: Suresh Krishnan
Cc: [email-masked]
Subject: Re: RFC 4861:-Link-Local address joining all-node multicast group.

Hi Suresh,

"When a multicast-capable interface becomes enabled, the node MUST join the all-nodes multicast address on that interface, as well as the solicited-    node multicast address corresponding to each of the IP addresses assigned to the interface."
Any idea What does this statement mean?
 
For the second query:-
 
I didnt change the MAC address of the card. I tried creating a new ipv6 address on the interface and I have seen these two unsolicited NA messages.My question is , Why the node is sending unsolicited NA message ( with source as "link-local address" & destination as "all-node multicast address").I am expecting only one unsolicited NA message( with source as "ipv6 global address" & destination as "all-node multicast address").  I am not at all changing the link-local address and the link-local address is already active on the interface. 
 
Regards,
Niviya

On Wed, Apr 21, 2010 at 4:22 AM, Suresh Krishnan <[email-masked]> wrote:
Hi Niviya, 

As described in section 6 of RFC3810 MLD reports are not sent for the all-nodes multicast address

.

It is unclear what the circumstances are. Specifically, what action did you perform that resulted in these messages? Did you change the MAC address of the card?
 
Hi Suresh,
 
I didnt change the MAC address of the card. I tried creating a new ipv6 address on the interface and I have seen these two unsolicited NA messages.My question is , Why the node is sending unsolicited NA message ( with source as "link-local address" & destination as "all-node multicast address").I am expecting only one unsolicited NA message( with source as "ipv6 global address" & destination as "all-node multicast address").  I am not at all changing the link-local address and the link-local address is already active on the interface. 

Cheers
Suresh

---

From: niviya vijayan <[email-masked]>
Date: Fri, 23 Apr 2010 12:05:07 +0530

Hi Shree,

On Wed, Apr 21, 2010 at 4:31 PM, JOSHI, SHRINIVAS ASHOK (SHRINIVAS ASHOK) <
[email-masked]> wrote:

> Niviya,
>
>
> >> "When a multicast-capable interface becomes enabled, the node MUST join
> Can u please tell me what protocol it will use ? Will it be a MLD
> report  with destination "all-node multicast address"? If it is yes, As per
> RFC3810, MLD report should not use for joining into all node multicast
> address.?
>

> >> Why the node is sending unsolicited NA message ( with source as
> "link-local address" & destination as "all-node multicast address").
> >> I am expecting only one unsolicited NA message( with source as "ipv6
> global address" & destination as "all-node multicast address").
> >> I am not at all changing the link-local address and the link-local
> address is already active on the interface.
>
>
>  as part of Duplicate Address Detection(source as unspecified address and
> destination as solicited node multicast address).
>
> What will happen if I didnt enable DAD ?

> From what you are seeing it looks like link layer address is getting
> changed, one way to verify it is through the override flag and source link
> layer address option
> Override flag is set and source link-layer address remains the same:-

> "When a multicast-capable interface becomes enabled, the node MUST join the
> to the interface."
> "When a multicast-capable interface becomes enabled, the node MUST join the
> to the interface."